function varargout = demo(varargin)
% DEMO M-file for demo.fig
%      DEMO, by itself, creates a new DEMO or raises the existing
%      singleton*.
%
%      H = DEMO returns the handle to a new DEMO or the handle to
%      the existing singleton*.
%
%      DEMO('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in DEMO.M with the given input arguments.
%
%      DEMO('Property','Value',...) creates a new DEMO or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before demo_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to demo_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help demo

% Last Modified by GUIDE v2.5 20-Jun-2010 18:25:25

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @demo_OpeningFcn, ...
                   'gui_OutputFcn',  @demo_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before demo is made visible.
function demo_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to demo (see VARARGIN)

% Choose default command line output for demo
handles.output = hObject;

handles.filepath = pwd;
handles.filepath_full = '';
handles.img = [];
imshow([], 'Parent', handles.axes_plain);
imshow([], 'Parent', handles.axes_cipher);
imshow([], 'Parent', handles.axes_decrypted);
imshow([], 'Parent', handles.axes_dcfree);
imshow([], 'Parent', handles.axes_USO);
imshow([], 'Parent', handles.axes_FRM);
set(handles.button_receive, 'Enable', 'off');
set(handles.button_dcfree, 'Enable', 'off');
set(handles.button_USO, 'Enable', 'off');
set(handles.button_FRM, 'Enable', 'off');

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes demo wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = demo_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in button_send.
function button_send_Callback(hObject, eventdata, handles)
% hObject    handle to button_send (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[filename,filepath] = uigetfile({'*.png;*.jpg;*.jpeg;*.bmp;*.gif;','Image Files (*.png;*.jpg;*.jpeg;*.bmp;*.gif;)';...
    '*.*','All Files (*.*)'},'Select an image for secret communication', handles.filepath);
if (isequal(filename,0) || isequal(filepath,0))
    return;
end
filepath_full = fullfile(filepath, filename);
if strcmp(filepath, handles.filepath_full)
    warndlg('Please select a different image file!', 'Warning');
    return;
end
try
    img_plain = imread(filepath_full);
catch me
    disp(me.message);
    errordlg('Please select a valid image file!', 'Warning');
    return;
end

% Disable buttons to avoid repeated clicks.
set(handles.button_send, 'Enable', 'off');
set(handles.button_receive, 'Enable', 'off');
set(handles.button_dcfree, 'Enable', 'off');
set(handles.button_USO, 'Enable', 'off');
set(handles.button_FRM, 'Enable', 'off');

handles.filepath = filepath;
handles.filepath_full = filepath_full;
img_plain = impad(img_plain);

handles.img_plain = img_plain;
handles.img_cipher = imencipher(img_plain);
handles.img_decrypted = [];
handles.img_dcfree = [];
handles.img_USO = [];
handles.img_FRM = [];

imshow(uint8(img_plain), 'Parent', handles.axes_plain);
imshow(uint8(im_scale_OR_shift(handles.img_cipher)), 'Parent', handles.axes_cipher);
imshow([], 'Parent', handles.axes_decrypted);
imshow([], 'Parent', handles.axes_dcfree);
imshow([], 'Parent', handles.axes_USO);
imshow([], 'Parent', handles.axes_FRM);

% Re-enable buttons to allow further operations.
set(handles.button_send, 'Enable', 'on');
set(handles.button_receive, 'Enable', 'on');
set(handles.button_dcfree, 'Enable', 'on');
set(handles.button_USO, 'Enable', 'on');
set(handles.button_FRM, 'Enable', 'on');

guidata(hObject, handles);


% --- Executes on button press in button_receive.
function button_receive_Callback(hObject, eventdata, handles)
% hObject    handle to button_receive (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if isempty(handles.img_cipher)
    return;
end

set(handles.button_send, 'Enable', 'off');
set(handles.button_receive, 'Enable', 'off');
set(handles.button_dcfree, 'Enable', 'off');
set(handles.button_USO, 'Enable', 'off');
set(handles.button_FRM, 'Enable', 'off');
imshow([], 'Parent', handles.axes_decrypted);
drawnow; % This is needed to update the status of the button and the contents of the axes.

handles.img_decrypted = imdecipher(handles.img_cipher);

guidata(hObject, handles);
imshow(uint8(im_scale_OR_shift(handles.img_decrypted)), 'Parent', handles.axes_decrypted);

set(handles.button_send, 'Enable', 'on');
set(handles.button_receive, 'Enable', 'on');
set(handles.button_dcfree, 'Enable', 'on');
set(handles.button_USO, 'Enable', 'on');
set(handles.button_FRM, 'Enable', 'on');


% --- Executes on button press in button_dcfree.
function button_dcfree_Callback(hObject, eventdata, handles)
% hObject    handle to button_dcfree (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if isempty(handles.img_cipher)
    return;
end

set(handles.button_send, 'Enable', 'off');
set(handles.button_receive, 'Enable', 'off');
set(handles.button_dcfree, 'Enable', 'off');
set(handles.button_USO, 'Enable', 'off');
set(handles.button_FRM, 'Enable', 'off');
imshow([], 'Parent', handles.axes_dcfree);
drawnow;

handles.img_dcfree = img_dcfree_get(handles.img_cipher);

guidata(hObject, handles);
imshow(uint8(im_scale_OR_shift(handles.img_dcfree)), 'Parent', handles.axes_dcfree);

set(handles.button_send, 'Enable', 'on');
set(handles.button_receive, 'Enable', 'on');
set(handles.button_dcfree, 'Enable', 'on');
set(handles.button_USO, 'Enable', 'on');
set(handles.button_FRM, 'Enable', 'on');


% --- Executes on button press in button_USO.
function button_USO_Callback(hObject, eventdata, handles)
% hObject    handle to button_USO (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if isempty(handles.img_cipher)
    return;
end

set(handles.button_send, 'Enable', 'off');
set(handles.button_receive, 'Enable', 'off');
set(handles.button_dcfree, 'Enable', 'off');
set(handles.button_USO, 'Enable', 'off');
set(handles.button_FRM, 'Enable', 'off');
imshow([], 'Parent', handles.axes_USO);
drawnow;

handles.img_USO = imrecover_USO(handles.img_cipher);

guidata(hObject, handles);
imshow(uint8(handles.img_USO), 'Parent', handles.axes_USO);

set(handles.button_send, 'Enable', 'on');
set(handles.button_receive, 'Enable', 'on');
set(handles.button_dcfree, 'Enable', 'on');
set(handles.button_USO, 'Enable', 'on');
set(handles.button_FRM, 'Enable', 'on');


% --- Executes on button press in button_FRM.
function button_FRM_Callback(hObject, eventdata, handles)
% hObject    handle to button_FRM (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if isempty(handles.img_cipher)
    return;
end

set(handles.button_send, 'Enable', 'off');
set(handles.button_receive, 'Enable', 'off');
set(handles.button_dcfree, 'Enable', 'off');
set(handles.button_USO, 'Enable', 'off');
set(handles.button_FRM, 'Enable', 'off');
imshow([], 'Parent', handles.axes_FRM);
drawnow;

h = waitbar(0, sprintf('Please wait, the process may last a few minutes...\nTime elapsed: 0 second'));
handles.img_FRM = imrecover_FRM(handles.img_cipher, [], h);
close(h);

guidata(hObject, handles);
imshow(uint8(handles.img_FRM), 'Parent', handles.axes_FRM);

set(handles.button_send, 'Enable', 'on');
set(handles.button_receive, 'Enable', 'on');
set(handles.button_dcfree, 'Enable', 'on');
set(handles.button_USO, 'Enable', 'on');
set(handles.button_FRM, 'Enable', 'on');
