function save_images(filename, type, varargin)
% save_images(filename, type, img_recovered)
% save_images(filename, type, img_scans)
% save_images(filename, type, img_recovered, img_dcfree)
% save_images(filename, type, img_recovered, img_scans)
% save_images(filename, type, img_recovered, img_dcfree, img_scans)
% save_images(filename, type, img_recovered, img_scans, img_dcfree)
% 
% This utility function saves a number of images for the Web site of our
% ICIP 2010 paper about the FRM method.
% The first input argument can include the file extension, if you want to
% which image format should be used. PNG format will be used if the
% extension is not given.
% The second argument declare which method is used ('USO' or 'FRM').
%
% Shujun Li @ www.hooklee.com 2010

if nargin<3
    disp('At least two input arguments are needed!');
    return;
end
[dir, filetitle, ext] = fileparts(filename);
filepath = fullfile(dir, filetitle);
if isempty(ext)
    ext = '.png';
end

switch numel(varargin)
    case 1
        if iscell(varargin{1})
            img_scans = varargin{1};
        else
            img_recovered = varargin{1};
        end
    case 2
        img_recovered = varargin{1};
        if iscell(varargin{2})
            img_scans = varargin{2};
        else
            img_dcfree = varargin{2};
        end
    case 3
        img_recovered = varargin{1};
        if iscell(varargin{2})
            img_scans = varargin{2};
            img_dcfree = varargin{3};
        else
            img_dcfree = varargin{2};
            img_scans = varargin{3};
        end
end

imwrite(uint8(im_scale_OR_shift(img_recovered)), [filepath '_' type ext]);
if exist('img_dcfree','var')
    imwrite(uint8(im_scale_OR_shift(img_dcfree)), [filepath '_dcfree' ext]);
end
if exist('img_scans','var')
    for i=1:numel(img_scans)
        imwrite(uint8(im_scale_OR_shift(img_scans{i})), [filepath '_' type '_Scan' num2str(i) ext]);
    end
end
